--- libmp3lame/psymodel.c.orig	2011-05-25 05:45:55.000000000 +0900
+++ libmp3lame/psymodel.c	2011-10-30 00:49:50.000000000 +0900
@@ -144,6 +144,12 @@
 # include <config.h>
 #endif
 
+#ifdef ALTIVEC
+#ifndef __APPLE_CC__
+#include <altivec.h>
+#endif
+#endif
+
 #include "lame.h"
 #include "machine.h"
 #include "encoder.h"
@@ -162,6 +168,48 @@
 #define  LN_TO_LOG10  0.2302585093
 #endif
 
+#ifdef ALTIVEC
+static inline vector float fast_log10_altivec_2(vector float v3)
+{
+    vector float va,vb,vc,vhalf,vzero,vsqrt2,vconst4;
+    vector float v1,v2,v4,v5,v6,v7,v8,vz,vz2,vlog;
+    vector unsigned int vconst1,vconst2,vshamt;
+    vector signed int vconst3;
+    
+    va = (vector float)VINIT4ALL(0.8685890659);
+    vb = (vector float)VINIT4ALL(0.2894672153);
+    vc = (vector float)VINIT4ALL(0.1793365895);
+    vhalf = (vector float)VINIT4ALL(0.15051499783);
+    vsqrt2 = (vector float)VINIT4ALL(1.4142135623731);
+    vconst4 = (vector float)VINIT4ALL(0.301029995664);
+    vzero = vec_xor(vzero,vzero);
+    vconst1 = (vector unsigned int)vec_sr(vec_splat_s32(-1),vec_splat_u32(9));
+    vconst2 = (vector unsigned int)vec_sr(vec_splat_s32(-1),vec_splat_u32(7));
+    vconst2 = vec_nor(vconst2,vconst2);
+    vconst3 = (vector signed int)vec_rl(vconst2,vec_splat_u32(7));
+    vshamt = vec_add(vec_splat_u32(9),vec_splat_u32(7));
+    vshamt = vec_add(vshamt,vec_splat_u32(7));
+    vconst2 = vec_sl((vector unsigned int)vconst3,vshamt);
+    
+    v4 = (vector float)vec_sel(vconst2,(vector unsigned int)v3,vconst1);
+    v5 = vec_add(v4,vsqrt2);
+    v6 = vec_sub(v4,vsqrt2);
+    v7 = vec_re(v5);
+    vz = vec_madd(v6, vec_madd(vec_nmsub(v7,v5,(vector float)vconst2),v7,v7), vzero);
+    v8 = (vector float)vec_sr((vector unsigned int)v3,vshamt);
+    vlog = vec_ctf(vec_sub((vector signed int)v8,vconst3),0);
+    
+    vz2 = vec_madd(vz,vz,vzero);
+    vlog = vec_madd(vlog,vconst4,vhalf);
+    
+    v1 = vec_madd(vz2,vc,vb);
+    v2 = vec_madd(vz2,v1,va);
+    vlog = vec_madd(vz,v2,vlog);
+    
+    return vlog;
+}
+#endif
+
 
 /*
    L3psycho_anal.  Compute psycho acoustics.
@@ -248,6 +296,10 @@
 static FLOAT ma_max_i1;
 static FLOAT ma_max_i2;
 static FLOAT ma_max_m;
+#ifdef ALTIVEC
+static vector float vmamax1 = (vector float)VINIT4ALL(3.651741);
+static vector float vmamax2 = (vector float)VINIT4ALL(31.622777);
+#endif
 
     /*This is the masking table:
        According to tonality, values are going from 0dB (TMN)
@@ -656,6 +708,14 @@
 vbrpsy_compute_fft_l(lame_internal_flags * gfc, const sample_t * const buffer[2], int chn,
                      int gr_out, FLOAT fftenergy[HBLKSIZE], FLOAT(*wsamp_l)[BLKSIZE])
 {
+#ifdef ALTIVEC
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,vhalf,vprev,vzero,vsqrt2;
+    vector unsigned char vperm;
+    vhalf = vec_ctf(vec_splat_s32(1),1);
+    vsqrt2 = (vector float)VINIT4ALL(0.7071067811865001);
+    vzero = vec_xor(vzero,vzero);
+    vperm = (vector unsigned char)VINIT16(0,1,2,3,28,29,30,31,24,25,26,27,20,21,22,23);
+#endif
     SessionConfig_t const *const cfg = &gfc->cfg;
     PsyStateVar_t *psv = &gfc->sv_psy;
     plotting_data *plt = cfg->analysis ? gfc->pinfo : 0;
@@ -665,19 +725,80 @@
         fft_long(gfc, *wsamp_l, chn, buffer);
     }
     else if (chn == 2) {
-        FLOAT const sqrt2_half = SQRT2 * 0.5f;
         /* FFT data for mid and side channel is derived from L & R */
+#ifdef ALTIVEC
+        for(j = 0; j < BLKSIZE; j += 8) {
+            v1 = vec_ld(0,wsamp_l[0]+j);
+            v2 = vec_ld(0,wsamp_l[1]+j);
+            v3 = vec_ld(16,wsamp_l[0]+j);
+            v4 = vec_ld(16,wsamp_l[1]+j);
+            
+            v5 = vec_add(v1,v2);
+            v6 = vec_sub(v1,v2);
+            v7 = vec_add(v3,v4);
+            v8 = vec_sub(v3,v4);
+            v9 = vec_madd(v5,vsqrt2,vzero);
+            v10 = vec_madd(v6,vsqrt2,vzero);
+            v11 = vec_madd(v7,vsqrt2,vzero);
+            v12 = vec_madd(v8,vsqrt2,vzero);
+            
+            vec_st(v9,0,wsamp_l[0]+j);
+            vec_st(v10,0,wsamp_l[1]+j);
+            vec_st(v11,16,wsamp_l[0]+j);
+            vec_st(v12,16,wsamp_l[1]+j);
+        }
+#else
+        FLOAT const sqrt2_half = SQRT2 * 0.5f;
         for (j = BLKSIZE - 1; j >= 0; --j) {
             FLOAT const l = wsamp_l[0][j];
             FLOAT const r = wsamp_l[1][j];
             wsamp_l[0][j] = (l + r) * sqrt2_half;
             wsamp_l[1][j] = (l - r) * sqrt2_half;
         }
+#endif
     }
 
     /*********************************************************************
     *  compute energies
     *********************************************************************/
+#ifdef ALTIVEC
+    vprev = vec_ld(0,(*wsamp_l));
+    for(j = 0; j < BLKSIZE/2; j += 16) {
+        v1 = vec_ld(0,(*wsamp_l)+j);
+        v2 = vec_ld(16,(*wsamp_l)+j);
+        v3 = vec_ld(32,(*wsamp_l)+j);
+        v4 = vec_ld(48,(*wsamp_l)+j);
+        v5 = vec_ld(48,(*wsamp_l)+1008-j);
+        v6 = vec_ld(32,(*wsamp_l)+1008-j);
+        v7 = vec_ld(16,(*wsamp_l)+1008-j);
+        v8 = vec_ld(0,(*wsamp_l)+1008-j);
+        v9 = vec_perm(vprev,v5,vperm);
+        v10 = vec_perm(v5,v6,vperm);
+        v11 = vec_perm(v6,v7,vperm);
+        v12 = vec_perm(v7,v8,vperm);
+        vprev = v8;
+        v1 = vec_madd(v1,v1,vzero);
+        v2 = vec_madd(v2,v2,vzero);
+        v3 = vec_madd(v3,v3,vzero);
+        v4 = vec_madd(v4,v4,vzero);
+        v5 = vec_madd(v9,v9,v1);
+        v6 = vec_madd(v10,v10,v2);
+        v7 = vec_madd(v11,v11,v3);
+        v8 = vec_madd(v12,v12,v4);
+        v9 = vec_madd(v5,vhalf,vzero);
+        v10 = vec_madd(v6,vhalf,vzero);
+        v11 = vec_madd(v7,vhalf,vzero);
+        v12 = vec_madd(v8,vhalf,vzero);
+        
+        vec_st(v9,0,fftenergy+j);
+        vec_st(v10,16,fftenergy+j);
+        vec_st(v11,32,fftenergy+j);
+        vec_st(v12,48,fftenergy+j);
+    }
+    
+    v1 = vec_madd(vprev,vprev,vzero);
+    vec_ste(v1,0,fftenergy+j);
+#else
     fftenergy[0] = wsamp_l[0][0];
     fftenergy[0] *= fftenergy[0];
 
@@ -686,13 +807,51 @@
         FLOAT const im = (*wsamp_l)[BLKSIZE / 2 + j];
         fftenergy[BLKSIZE / 2 - j] = (re * re + im * im) * 0.5f;
     }
+#endif
     /* total energy */
     {
+#ifdef ALTIVEC
+#ifdef ALTIVEC_970
+        v5 = vec_ld(0,fftenergy+8);
+        v6 = vec_ld(0,fftenergy+508);
+        v7 = vec_ld(0,fftenergy+512);
+        v8 = vec_xor(v8,v8);
+        v5 = vec_sld(v5,v8,12);
+        v7 = vec_sld(v8,v7,4);
+#else
+        v5 = vec_lde(0,fftenergy+11);
+        v6 = vec_ld(0,fftenergy+508);
+        v7 = vec_lde(0,fftenergy+512);
+        v8 = vec_xor(v8,v8);
+#endif
+        for(j=12;j<508;j+=16) {
+            v1 = vec_ld(0,fftenergy+j);
+            v2 = vec_ld(16,fftenergy+j);
+            v3 = vec_ld(32,fftenergy+j);
+            v4 = vec_ld(48,fftenergy+j);
+            v5 = vec_add(v1,v5);
+            v6 = vec_add(v2,v6);
+            v7 = vec_add(v3,v7);
+            v8 = vec_add(v4,v8);
+        }
+        v5 = vec_add(v5,v6);
+        v7 = vec_add(v7,v8);
+        v5 = vec_add(v5,v7);
+        v6 = vec_sld(v5,v5,4);
+        v7 = vec_sld(v5,v5,8);
+        v8 = vec_sld(v5,v5,12);
+        v5 = vec_add(v5,v6);
+        v7 = vec_add(v7,v8);
+        v5 = vec_add(v5,v7);
+        v5 = vec_perm(v5,v5,vec_lvsr(0, psv->tot_ener+chn));
+        vec_ste(v5,0,psv->tot_ener+chn);
+#else
         FLOAT   totalenergy = 0.0f;
         for (j = 11; j < HBLKSIZE; j++)
             totalenergy += fftenergy[j];
 
         psv->tot_ener[chn] = totalenergy;
+#endif
     }
 
     if (plt) {
@@ -706,27 +865,96 @@
 
 static void
 vbrpsy_compute_fft_s(lame_internal_flags const *gfc, const sample_t * const buffer[2], int chn,
-                     int sblock, FLOAT(*fftenergy_s)[HBLKSIZE_s], FLOAT(*wsamp_s)[3][BLKSIZE_s])
+                     int sblock, FLOAT(*fftenergy_s)[HBLKSIZE_s+3], FLOAT(*wsamp_s)[3][BLKSIZE_s])
 {
+#ifdef ALTIVEC
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,vhalf,vprev,vzero,vsqrt2;
+    vector unsigned char vperm;
+    vhalf = vec_ctf(vec_splat_s32(1),1);
+    vsqrt2 = (vector float)VINIT4ALL(0.7071067811865001);
+    vzero = vec_xor(vzero,vzero);
+    vperm = (vector unsigned char)VINIT16(0,1,2,3,28,29,30,31,24,25,26,27,20,21,22,23);
+#endif
     int     j;
 
     if (sblock == 0 && chn < 2) {
         fft_short(gfc, *wsamp_s, chn, buffer);
     }
     if (chn == 2) {
-        FLOAT const sqrt2_half = SQRT2 * 0.5f;
         /* FFT data for mid and side channel is derived from L & R */
+#ifdef ALTIVEC
+        for(j = 0; j < BLKSIZE_s; j += 8) {
+            v1 = vec_ld(0,wsamp_s[0][sblock]+j);
+            v2 = vec_ld(0,wsamp_s[1][sblock]+j);
+            v3 = vec_ld(16,wsamp_s[0][sblock]+j);
+            v4 = vec_ld(16,wsamp_s[1][sblock]+j);
+            
+            v5 = vec_add(v1,v2);
+            v6 = vec_sub(v1,v2);
+            v7 = vec_add(v3,v4);
+            v8 = vec_sub(v3,v4);
+            v9 = vec_madd(v5,vsqrt2,vzero);
+            v10 = vec_madd(v6,vsqrt2,vzero);
+            v11 = vec_madd(v7,vsqrt2,vzero);
+            v12 = vec_madd(v8,vsqrt2,vzero);
+            
+            vec_st(v9,0,wsamp_s[0][sblock]+j);
+            vec_st(v10,0,wsamp_s[1][sblock]+j);
+            vec_st(v11,16,wsamp_s[0][sblock]+j);
+            vec_st(v12,16,wsamp_s[1][sblock]+j);
+        }
+#else
+        FLOAT const sqrt2_half = SQRT2 * 0.5f;
         for (j = BLKSIZE_s - 1; j >= 0; --j) {
             FLOAT const l = wsamp_s[0][sblock][j];
             FLOAT const r = wsamp_s[1][sblock][j];
             wsamp_s[0][sblock][j] = (l + r) * sqrt2_half;
             wsamp_s[1][sblock][j] = (l - r) * sqrt2_half;
         }
+#endif
     }
 
     /*********************************************************************
     *  compute energies
     *********************************************************************/
+#ifdef ALTIVEC
+    vprev = vec_ld(0,(*wsamp_s)[sblock]);
+    for(j = 0; j < BLKSIZE_s/2; j += 16) {
+        v1 = vec_ld(0,(*wsamp_s)[sblock]+j);
+        v2 = vec_ld(16,(*wsamp_s)[sblock]+j);
+        v3 = vec_ld(32,(*wsamp_s)[sblock]+j);
+        v4 = vec_ld(48,(*wsamp_s)[sblock]+j);
+        v5 = vec_ld(48,(*wsamp_s)[sblock]+240-j);
+        v6 = vec_ld(32,(*wsamp_s)[sblock]+240-j);
+        v7 = vec_ld(16,(*wsamp_s)[sblock]+240-j);
+        v8 = vec_ld(0,(*wsamp_s)[sblock]+240-j);
+        v9 = vec_perm(vprev,v5,vperm);
+        v10 = vec_perm(v5,v6,vperm);
+        v11 = vec_perm(v6,v7,vperm);
+        v12 = vec_perm(v7,v8,vperm);
+        vprev = v8;
+        v1 = vec_madd(v1,v1,vzero);
+        v2 = vec_madd(v2,v2,vzero);
+        v3 = vec_madd(v3,v3,vzero);
+        v4 = vec_madd(v4,v4,vzero);
+        v5 = vec_madd(v9,v9,v1);
+        v6 = vec_madd(v10,v10,v2);
+        v7 = vec_madd(v11,v11,v3);
+        v8 = vec_madd(v12,v12,v4);
+        v9 = vec_madd(v5,vhalf,vzero);
+        v10 = vec_madd(v6,vhalf,vzero);
+        v11 = vec_madd(v7,vhalf,vzero);
+        v12 = vec_madd(v8,vhalf,vzero);
+        
+        vec_st(v9,0,fftenergy_s[sblock]+j);
+        vec_st(v10,16,fftenergy_s[sblock]+j);
+        vec_st(v11,32,fftenergy_s[sblock]+j);
+        vec_st(v12,48,fftenergy_s[sblock]+j);
+    }
+    
+    v1 = vec_madd(vprev,vprev,vzero);
+    vec_ste(v1,0,fftenergy_s[sblock]+j);
+#else
     fftenergy_s[sblock][0] = (*wsamp_s)[sblock][0];
     fftenergy_s[sblock][0] *= fftenergy_s[sblock][0];
     for (j = BLKSIZE_s / 2 - 1; j >= 0; --j) {
@@ -734,6 +962,7 @@
         FLOAT const im = (*wsamp_s)[sblock][BLKSIZE_s / 2 + j];
         fftenergy_s[sblock][BLKSIZE_s / 2 - j] = (re * re + im * im) * 0.5f;
     }
+#endif
 }
 
 
@@ -762,7 +991,24 @@
                         FLOAT energy[4], FLOAT sub_short_factor[4][3], int ns_attacks[4][4],
                         int uselongblock[2])
 {
-    FLOAT   ns_hpfsmpl[2][576];
+#ifdef ALTIVEC
+    vector float v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16;
+    vector float vsum,vsum1,vsum2,vsuma,vsumb,vsumc,vsumd,vmaska,vmaskb,vmaskc,vmaskd;
+    vector unsigned char vmask1,vmask2,vmask3,vmask4,vmask1inv,vmask2inv,vmask3inv,vmask4inv,vperm,vs4,vs8,vs12;
+    
+    vperm = (vector unsigned char)VINIT16(12,13,14,15,8,9,10,11,4,5,6,7,0,1,2,3);
+    v1 = (vector float)vec_splat_u8(1);
+    v2 = (vector float)vec_splat_u8(5);
+    vs4 = vec_sl((vector unsigned char)v1,(vector unsigned char)v2);
+    vs8 = vec_sl(vs4,(vector unsigned char)v1);
+    vs12 = vec_or(vs4,vs8);
+    v3 = (vector float)vec_splat_s32(-1);
+    vmaska = vec_slo(v3,vs12);
+    vmaskb = vec_sro(vmaska,vs4);
+    vmaskc = vec_sro(vmaska,vs8);
+    vmaskd = vec_sro(vmaska,vs12);
+#endif
+    FLOAT   ns_hpfsmpl[2][576] __attribute__ ((aligned (16)));
     SessionConfig_t const *const cfg = &gfc->cfg;
     PsyStateVar_t *const psv = &gfc->sv_psy;
     plotting_data *plt = cfg->analysis ? gfc->pinfo : 0;
@@ -775,14 +1021,142 @@
     /* Don't copy the input buffer into a temporary buffer */
     /* unroll the loop 2 times */
     for (chn = 0; chn < n_chn_out; chn++) {
-        static const FLOAT fircoef[] = {
+        static const FLOAT fircoef[] __attribute__ ((aligned (16))) = {
             -8.65163e-18 * 2, -0.00851586 * 2, -6.74764e-18 * 2, 0.0209036 * 2,
             -3.36639e-17 * 2, -0.0438162 * 2, -1.54175e-17 * 2, 0.0931738 * 2,
-            -5.52212e-17 * 2, -0.313819 * 2
+            -5.52212e-17 * 2, -0.313819 * 2, 0.0, 0.0
         };
         /* apply high pass filter of fs/4 */
         const sample_t *const firbuf = &buffer[chn][576 - 350 - NSFIRLEN + 192];
-        assert(dimension_of(fircoef) == ((NSFIRLEN - 1) / 2));
+        //assert(dimension_of(fircoef) == ((NSFIRLEN - 1) / 2));
+#ifdef ALTIVEC
+        v1 = vec_ld(0, firbuf+10);
+        vmask1 = vec_lvsl(0, firbuf);
+        vmask2 = vec_lvsl(0, firbuf+1);
+        vmask3 = vec_lvsl(0, firbuf+2);
+        vmask4 = vec_lvsl(0, firbuf+3);
+        vmask1inv = vec_perm(vmask1,vmask1,vperm);
+        vmask2inv = vec_perm(vmask2,vmask2,vperm);
+        vmask3inv = vec_perm(vmask3,vmask3,vperm);
+        vmask4inv = vec_perm(vmask4,vmask4,vperm);
+        for(i=0;i<576;) {
+            v2 = vec_ld(16,firbuf+i+10);
+            vsum1 = vec_perm(v1, v2, vmask3);
+            v1 = v2;
+            
+            vsum2 = vec_splat(vsum1, 0);
+            vsum = vec_and(vsum2, vmaska);
+            v3 = vec_ld(0, firbuf+i);
+            v4 = vec_ld(16,firbuf+i+NSFIRLEN-3);
+            for(j=0;j<(NSFIRLEN-1)/2;j+=4) {
+                v5 = vec_ld(16, firbuf+i+j);
+                v6 = vec_ld(0, firbuf+i+NSFIRLEN-3-j);
+                v7 = vec_perm(v3,v5,vmask1);
+                v8 = vec_perm(v6,v4,vmask3inv);
+                v3 = v5;
+                v4 = v6;
+                v10 = vec_ld(0,fircoef+j);
+                v11 = vec_add(v7,v8);
+                vsum = vec_madd(v10,v11,vsum);
+            }
+            
+            v12 = vec_slo(vsum,vs4);
+            v13 = vec_slo(vsum,vs8);
+            v14 = vec_slo(vsum,vs12);
+            v15 = vec_add(vsum,v12);
+            v16 = vec_add(v13,v14);
+            vsuma = vec_add(v15,v16);
+            vsuma = vec_and(vsuma,vmaska);
+            
+            i++;
+            
+            vsum2 = vec_splat(vsum1, 1);
+            vsum = vec_and(vsum2, vmaska);
+            v3 = vec_ld(0, firbuf+i);
+            v4 = vec_ld(16,firbuf+i+NSFIRLEN-3);
+            vmask2 = vec_lvsl(0, firbuf+i);
+            for(j=0;j<(NSFIRLEN-1)/2;j+=4) {
+                v5 = vec_ld(16, firbuf+i+j);
+                v6 = vec_ld(0, firbuf+i+NSFIRLEN-3-j);
+                v7 = vec_perm(v3,v5,vmask2);
+                v8 = vec_perm(v6,v4,vmask4inv);
+                v3 = v5;
+                v4 = v6;
+                v10 = vec_ld(0,fircoef+j);
+                v11 = vec_add(v7,v8);
+                vsum = vec_madd(v10,v11,vsum);
+            }
+            
+            v12 = vec_sro(vsum,vs4);
+            v13 = vec_slo(vsum,vs4);
+            v14 = vec_slo(vsum,vs8);
+            v15 = vec_add(vsum,v12);
+            v16 = vec_add(v13,v14);
+            vsumb = vec_add(v15,v16);
+            vsumb = vec_and(vsumb,vmaskb);
+            
+            i++;
+            
+            vsum2 = vec_splat(vsum1, 2);
+            vsum = vec_and(vsum2, vmaska);
+            v3 = vec_ld(0, firbuf+i);
+            v4 = vec_ld(16,firbuf+i+NSFIRLEN-3);
+            vmask2 = vec_lvsl(0, firbuf+i);
+            for(j=0;j<(NSFIRLEN-1)/2;j+=4) {
+                v5 = vec_ld(16, firbuf+i+j);
+                v6 = vec_ld(0, firbuf+i+NSFIRLEN-3-j);
+                v7 = vec_perm(v3,v5,vmask3);
+                v8 = vec_perm(v6,v4,vmask1inv);
+                v3 = v5;
+                v4 = v6;
+                v10 = vec_ld(0,fircoef+j);
+                v11 = vec_add(v7,v8);
+                vsum = vec_madd(v10,v11,vsum);
+            }
+            
+            v12 = vec_sro(vsum,vs4);
+            v13 = vec_sro(vsum,vs8);
+            v14 = vec_slo(vsum,vs4);
+            v15 = vec_add(vsum,v12);
+            v16 = vec_add(v13,v14);
+            vsumc = vec_add(v15,v16);
+            vsumc = vec_and(vsumc,vmaskc);
+            
+            i++;
+            
+            vsum2 = vec_splat(vsum1, 3);
+            vsum = vec_and(vsum2, vmaska);
+            v3 = vec_ld(0, firbuf+i);
+            v4 = vec_ld(16,firbuf+i+NSFIRLEN-3);
+            vmask2 = vec_lvsl(0, firbuf+i);
+            for(j=0;j<(NSFIRLEN-1)/2;j+=4) {
+                v5 = vec_ld(16, firbuf+i+j);
+                v6 = vec_ld(0, firbuf+i+NSFIRLEN-3-j);
+                v7 = vec_perm(v3,v5,vmask4);
+                v8 = vec_perm(v6,v4,vmask2inv);
+                v3 = v5;
+                v4 = v6;
+                v10 = vec_ld(0,fircoef+j);
+                v11 = vec_add(v7,v8);
+                vsum = vec_madd(v10,v11,vsum);
+            }
+            
+            v12 = vec_sro(vsum,vs4);
+            v13 = vec_sro(vsum,vs8);
+            v14 = vec_sro(vsum,vs12);
+            v15 = vec_add(vsum,v12);
+            v16 = vec_add(v13,v14);
+            vsumd = vec_add(v15,v16);
+            vsumd = vec_and(vsumd,vmaskd);
+            
+            vsum1 = vec_or(vsuma,vsumb);
+            vsum2 = vec_or(vsumc,vsumd);
+            vsum = vec_or(vsum1,vsum2);
+            
+            i++;
+            vec_st(vsum,0,ns_hpfsmpl[chn]+i-4);
+        }
+#else
         for (i = 0; i < 576; i++) {
             FLOAT   sum1, sum2;
             sum1 = firbuf[i + 10];
@@ -793,6 +1167,7 @@
             }
             ns_hpfsmpl[chn][i] = sum1 + sum2;
         }
+#endif
         masking_ratio[gr_out][chn].en = psv->en[chn];
         masking_ratio[gr_out][chn].thm = psv->thm[chn];
         if (n_chn_psy > 2) {
@@ -831,9 +1206,28 @@
         for (i = 0; i < 9; i++) {
             FLOAT const *const pfe = pf + 576 / 9;
             FLOAT   p = 1.;
+#ifdef ALTIVEC
+            FLOAT vmax[4] __attribute__ ((aligned (16)));
+            v1 = (vector float)vec_splat_s32(1);
+            v2 = vec_ctf((vector signed int)v1,0);
+            for (; pf < pfe; pf+=4) {
+                v3 = vec_ld(0,pf);
+                v4 = vec_abs(v3);
+                v2 = vec_max(v2,v4);
+            }
+            v5 = vec_slo(v2,vs4);
+            v6 = vec_slo(v2,vs8);
+            v7 = vec_slo(v2,vs12);
+            v8 = vec_max(v2,v5);
+            v9 = vec_max(v6,v7);
+            v10 =vec_max(v8,v9);
+            vec_st(v10,0,vmax);
+            p = vmax[0];
+#else
             for (; pf < pfe; pf++)
                 if (p < fabs(*pf))
                     p = fabs(*pf);
+#endif
             psv->last_en_subshort[chn][i] = en_subshort[i + 3] = p;
             en_short[1 + i / 3] += p;
             if (p > en_subshort[i + 3 - 2]) {
@@ -1029,7 +1423,7 @@
 
 
 static void
-vbrpsy_compute_masking_s(lame_internal_flags * gfc, const FLOAT(*fftenergy_s)[HBLKSIZE_s],
+vbrpsy_compute_masking_s(lame_internal_flags * gfc, const FLOAT(*fftenergy_s)[HBLKSIZE_s+3],
                          FLOAT * eb, FLOAT * thr, int chn, int sblock)
 {
     PsyStateVar_t *const psv = &gfc->sv_psy;
